// Reference

#include <iostream>
using namespace std;

// Pedvn parametru odkazem (pomoc reference na l-hodnotu)
void inkrement(int &n)
{
	n = n + 1;
}

void proho_r(int& a, int& b)
{
	int c = a;
	a = b;
	b = c;
}

// Pedvn ukazatelem
void proho_u(int* a, int* b)
{
	int c = *a;
	*a = *b;
	*b = c;
}

void zpracuj(int& a)
{
	a++;
	cout << "reference na l-hodnotu" << endl;
}

// Pedvn pomoc reference na r-hodnotu
void zpracuj(int&& a)
{
	cout << a << "reference na r-hodnotu" << endl;
}

int main()
{
	int a = 10;
	int* q = &a;
	inkrement(*q);

	int& r = a;

	q = &r;
	cout << a << endl;

	int d = 11, e = 12;
	cout << d << " " << e << endl;
	proho_r(d, e);
	cout << d << " " << e << endl;

	proho_u(&d, &e);
	cout << d << " " << e << endl;

	zpracuj(d);
	zpracuj(d + 1);
}

