#include <iostream>
#include <stdexcept>
#include "Funkce.h"
using namespace std;

// Zkladn tvar deklarace funkce
inline int Max(int a, int b) 
{
	return a > b ? a : b;
}

// Nvratov typ vzady
auto Max(double a, double b) -> double
{
	return a > b ? a : b;
}

// Peklada si odvod nvratov typ sm
auto Max(char a, char b)
{
	return a > b ? a : b;
}

// Toto je ablona!!
auto souet(auto a, auto b)  
{
	return a + b;
}

// Obvykl deklarace ablony funkce
template<typename T>
T Max(T a, T b)
{
	return a > b ? a : b;
}

// Zde se hodil typ vzadu 
template<typename T, typename U>
auto souet1(T a, U b) -> decltype(a+b)
{
	return a + b;
}

int main()
{
	cout << Max(10, 20) << endl;
	cout << Max(10l, 20l) << endl;
	//cout << Min(10, 44) << endl; // Nelze -- nen zde vidt
}